/* Start/Stop Script for the CATALINA Server */
/* Modification log                         *//*
2002.8   orca
   Tomcat 4.0.4 XNvg"catalina.sh"Ƃɂč쐬
*/
options translate('ETmode')

parse source . . PRG /* symbolic link̂Ƃ͖ */
PRGDIR = FileSpec('Drive', PRG)FileSpec('Path', PRG)
PRGDIR = left(PRGDIR, length(PRGDIR) -1)

saveddir = Directory()
CATALINA_HOME = Directory(PRGDIR'/..')
call Directory saveddir
if stream(CATALINA_HOME'/bin/setenv.cmd', 'c', 'query exists') \== '' then
   '@call "'translate(CATALINA_HOME'/bin/setenv.cmd"', '\', '/')

if stream(CATALINA_HOME'/bin/setclasspath.cmd', 'c', 'query exists') \== '' then do
   '@call "'translate(CATALINA_HOME'/bin/setclasspath.cmd"', '\', '/'),
         CATALINA_HOME /* BASEDIR */
   if datatype(Rc, 'W') then if Rc > 0 then exit Rc
end
else do
   say 'Cannot find 'CATALINA_HOME'/bin/setclasspath.cmd'
   say 'This file is needed to run this program'
   exit 1
end

call getenv 'JAVA_HOME'
call getenv 'CLASSPATH'
call getenv 'JAVA_ENDORSED_DIRS'
call getenv '_RUNJAVA'
call getenv '_RUNJDB'

if getenv('JSSE_HOME') \== '' then
   CLASSPATH = CLASSPATH || JSSE_HOME'/lib/jcert.jar;'JSSE_HOME'/lib/jnet.jar;'JSSE_HOME'/lib/jsse.jar;'
CLASSPATH = CLASSPATH ||CATALINA_HOME'/bin/bootstrap.jar;'

/*CATALINA_HOME = FileSpec('P', CATALINA_HOME)FileSpec('N', CATALINA_HOME)*/
if getenv('CATALINA_BASE') == '' then
   CATALINA_BASE = CATALINA_HOME

if getenv('CATALINA_TMPDIR') == '' then
   /* Define the java.io.tmpdir to use for Catalina */
   CATALINA_TMPDIR = CATALINA_BASE'/temp'

say 'Using CATALINA_BASE:   'CATALINA_BASE
say 'Using CATALINA_HOME:   'CATALINA_HOME
say 'Using CATALINA_TMPDIR: 'CATALINA_TMPDIR
say 'Using JAVA_HOME:       'JAVA_HOME

parse arg ARGS

if word(ARGS, 1) == 'jpda' then do
   if getenv('JPDA_TRANSPORT') == '' then
      JPDA_TRANSPORT = 'dt_socket'
   if getenv('JPDA_ADDRESS') == '' then
      JPDA_ADDRESS = 8000
   if getenv('JPDA_OPTS') == '' then
      JPDA_OPTS = '-Xdebug -Xrunjdwp:transport='JPDA_TRANSPORT',address='JPDA_ADDRESS',server=y,suspend=n'

   call getenv 'CATALINA_OPTS'
   CATALINA_OPTS = CATALINA_OPTS JPDA_OPTS
   parse var ARGS . ARGS
end

call getenv 'JAVA_OPTS'
call getenv 'CATALINA_OPTS'

if word(ARGS, 1) == 'debug' then do

   parse var ARGS . ARGS
   if word(ARGS, 1) == '-security' then do
      say 'Using Security Manager'
      parse var ARGS . ARGS
      _RUNJDB JAVA_OPTS CATALINA_OPTS,
            '-Djava.endorsed.dirs='JAVA_ENDORSED_DIRS' -classpath 'CLASSPATH,
            '-sourcepath 'CATALINA_HOME'/../jakarta-tomcat-4.0/catalina/src/share',
            '-Djava.security.manager',
            '-Djava.security.policy=='CATALINA_BASE'/conf/catalina.policy',
            '-Dcatalina.base='CATALINA_BASE,
            '-Dcatalina.home='CATALINA_HOME,
            '-Djava.io.tmpdir='CATALINA_TMPDIR,
            'org.apache.catalina.startup.Bootstrap 'ARGS' start'
   end
   else do
      _RUNJDB JAVA_OPTS CATALINA_OPTS,
            '-Djava.endorsed.dirs='JAVA_ENDORSED_DIRS' -classpath 'CLASSPATH,
            '-sourcepath 'CATALINA_HOME'/../jakarta-tomcat-4.0/catalina/src/share',
            '-Dcatalina.base='CATALINA_BASE,
            '-Dcatalina.home='CATALINA_HOME,
            '-Djava.io.tmpdir='CATALINA_TMPDIR,
            'org.apache.catalina.startup.Bootstrap 'ARGS' start'
   end

end
else if word(ARGS, 1) == 'embedded' then do

   parse var ARGS . ARGS
   say 'Embedded Classpath: 'CLASSPATH
   _RUNJAVA JAVA_OPTS CATALINA_OPTS,
         '-Djava.endorsed.dirs='JAVA_ENDORSED_DIRS' -classpath 'CLASSPATH,
         '-Dcatalina.base='CATALINA_BASE,
         '-Dcatalina.home='CATALINA_HOME,
         '-Djava.io.tmpdir='CATALINA_TMPDIR,
         'org.apache.catalina.startup.Embedded 'ARGS

end
else if word(ARGS, 1) == 'run' then do

   parse var ARGS . ARGS
   if word(ARGS, 1) == '-security' then do
      say 'Using Security Manager'
      parse var ARGS . ARGS
      _RUNJAVA JAVA_OPTS CATALINA_OPTS,
            '-Djava.endorsed.dirs='JAVA_ENDORSED_DIRS' -classpath 'CLASSPATH,
            '-Djava.security.manager',
            '-Djava.security.policy=='CATALINA_BASE'/conf/catalina.policy',
            '-Dcatalina.base='CATALINA_BASE,
            '-Dcatalina.home='CATALINA_HOME,
            '-Djava.io.tmpdir='CATALINA_TMPDIR,
            'org.apache.catalina.startup.Bootstrap 'ARGS' start'
   end
   else do
      _RUNJAVA JAVA_OPTS CATALINA_OPTS,
            '-Djava.endorsed.dirs='JAVA_ENDORSED_DIRS' -classpath 'CLASSPATH,
            '-Dcatalina.base='CATALINA_BASE,
            '-Dcatalina.home='CATALINA_HOME,
            '-Djava.io.tmpdir='CATALINA_TMPDIR,
            'org.apache.catalina.startup.Bootstrap 'ARGS' start'
   end

end
else if word(ARGS, 1) == 'start' then do

   parse var ARGS . ARGS
   call SysFileDelete CATALINA_BASE'/logs/catalina.out' /*'touch 'CATALINA_BASE'/logs/catalina.out'*/
   if word(ARGS, 1) == '-security' then do
      say 'Using Security Manager'
      parse var ARGS . ARGS
      'start' _RUNJAVA JAVA_OPTS CATALINA_OPTS,
            '-Djava.endorsed.dirs='JAVA_ENDORSED_DIRS' -classpath 'CLASSPATH,
            '-Djava.security.manager',
            '-Djava.security.policy=='CATALINA_BASE'/conf/catalina.policy',
            '-Dcatalina.base='CATALINA_BASE,
            '-Dcatalina.home='CATALINA_HOME,
            '-Djava.io.tmpdir='CATALINA_TMPDIR,
            'org.apache.catalina.startup.Bootstrap 'ARGS' start',
            '>> 'CATALINA_BASE'/logs/catalina.out 2>&1 '
   end
   else do
      'start' _RUNJAVA JAVA_OPTS CATALINA_OPTS,
            '-Djava.endorsed.dirs='JAVA_ENDORSED_DIRS' -classpath 'CLASSPATH,
            '-Dcatalina.base='CATALINA_BASE,
            '-Dcatalina.home='CATALINA_HOME,
            '-Djava.io.tmpdir='CATALINA_TMPDIR,
            'org.apache.catalina.startup.Bootstrap 'ARGS' start',
            '>> 'CATALINA_BASE'/logs/catalina.out 2>&1 '
   end

end
else if word(ARGS, 1) == 'stop' then do

   parse var ARGS . ARGS
   _RUNJAVA JAVA_OPTS CATALINA_OPTS,
         '-Djava.endorsed.dirs='JAVA_ENDORSED_DIRS' -classpath 'CLASSPATH,
         '-Dcatalina.base='CATALINA_BASE,
         '-Dcatalina.home='CATALINA_HOME,
         '-Djava.io.tmpdir='CATALINA_TMPDIR,
         'org.apache.catalina.startup.Bootstrap 'ARGS' stop'

end
else do

   say 'Usage: catalina.sh ( commands ... )'
   say 'commands:'
   say '  debug             Start Catalina in a debugger'
   say '  debug -security   Debug Catalina with a security manager'
   say '  embedded          Start Catalina in embedded mode'
   say '  jpda start        Start Catalina under JPDA debugger'
   say '  run               Start Catalina in the current window'
   say '  run -security     Start in the current window with security manager'
   say '  start             Start Catalina in a separate window'
   say '  start -security   Start in a separate window with security manager'
   say '  stop              Stop Catalina'
   exit 1

end
exit


getenv:
   if symbol(arg(1)) == 'LIT' then
      call value arg(1), value(arg(1),, 'OS2ENVIRONMENT')
   return value(arg(1))

/**  End of Script  **/
